//-----------------------------------------------------------------------------
// Projet               : La physique amusante 1
// Class                : Elastique.pde
// Auteur               : Sylvain Blocquaux
// Date                 : 13 avril 2011
// Version              : 1.0
//-----------------------------------------------------------------------------

class Elastique {
  PVector pointAncre;
  Mobile pointMobile;
  float longueurRepos = 200; // longueur au repos en pixel
  float forceK = 5; // Constant de raideur en N.m-1
  int correction = 60; 

  Elastique(PVector pointA, Mobile pointB) {
    pointAncre = pointA;
    pointMobile = pointB;
  }

  void calculForce() {
    PVector rappel = PVector.sub(pointMobile.position, pointAncre); // Vecteur du déplacement
    float longueur = rappel.mag();
    float etirement = longueur - longueurRepos; // Calcul de l'étirement
    if (etirement > 0) {
      rappel.normalize();
      rappel.mult((-1) * forceK * etirement / correction); // Calcul de la force de rappel
      pointMobile.force = rappel;
    }
  }

  void afficher() {
    line(pointMobile.position.x,  pointMobile.position.y, pointAncre.x,pointAncre.y);
  }
}

